<!DOCTYPE HTML SYSTEM>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Brakeman Report</title>
  <script type="text/javascript" src="https://code.jquery.com/jquery-2.1.4.min.js"></script>
  <script type="text/javascript" src="https://cdn.datatables.net/1.10.9/js/jquery.dataTables.min.js"></script>
  <script type="text/javascript">
    function toggle(context) {
      var elem = document.getElementById(context);

      if (elem.style.display != "block")
        elem.style.display = "block";
      else
        elem.style.display = "none";

      elem.parentNode.scrollIntoView();
    }

    $(document).ready(function() {
      $('table').DataTable({
        searching: false,
        paging:    false,
        info:      false
      });
    });
  </script>
  <style>
    /* CSS style used for HTML reports */

body {
  font-family: sans-serif;
  color: #161616;
}

a {
  color: #161616;
}

p {
  font-weight: bold;
  font-size: 11pt;
  color: #2D0200;
 }

 th {
   background-color: #980905;
   border-bottom: 5px solid #530200;
   color: white;
   font-size: 11pt;
   padding: 1px 8px 1px 8px;
 }

 td {
   border-bottom: 2px solid white;
   font-family: monospace;
   padding: 5px 8px 1px 8px;
 }

 table {
   background-color: #FCF4D4;
   border-collapse: collapse;
 }

 h1 {
   color: #2D0200;
   font-size: 14pt;
 }

 h2 {
   color: #2D0200;
   font-size: 12pt;
 }

 span.high-confidence {
   font-weight:bold;
   color: red;
 }

 span.med-confidence {
 }

 span.weak-confidence {
   color:gray;
 }

 div.warning_message {
   cursor: pointer;
 }

 div.warning_message:hover {
   background-color: white;
 }

 table caption {
   background-color: #FFE;
   padding: 2px;
 }

 table.context {
   margin-top: 5px;
   margin-bottom: 5px;
   border-left: 1px solid #90e960;
   color: #212121;
 }

 tr.context {
   background-color: white;
 }

 tr.first {
   border-top: 1px solid #7ecc54;
   padding-top: 2px;
 }

 tr.error {
  background-color: #f4c1c1 !important
 }

 tr.near_error {
  background-color: #f4d4d4 !important
 }

 tr.alt {
   background-color: #e8f4d4;
 }

 td.context {
   padding: 2px 10px 0px 6px;
   border-bottom: none;
 }

 td.context_line {
   padding: 2px 8px 0px 7px;
   border-right: 1px solid #b3bda4;
   border-bottom: none;
   color: #6e7465;
 }

 pre.context {
   margin-bottom: 1px;
 }

 .user_input {
   background-color: #fcecab;
 }

 div.render_path {
   display: none;
   background-color: #ffe;
   padding: 5px;
   margin: 2px 0px 2px 0px;
 }

 div.template_name {
   cursor: pointer;
 }

 div.template_name:hover {
   background-color: white;
 }

 span.code {
   font-family: monospace;
 }

 span.filename {
   font-family: monospace;
 }

  </style>
</head>
<body>

<h1>Brakeman Report</h1>
<table>
  <thead>
    <tr>
      <th>Application Path</th>
      <th>Rails Version</th>
      <th>Brakeman Version</th>
      <th>Report Time</th>
      <th>Checks Performed</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td>/Volumes/Asaheim/NETiKA/Owasp/bad-secure-rails-app</td>
      <td>7.0.4</td>
      <td>5.3.1
      <td>
        2022-10-16 19:03:32 +0200<br><br>
        0.470732 seconds
      </td>
      <td>BasicAuth, BasicAuthTimingAttack, CSRFTokenForgeryCVE, ContentTag, CookieSerialization, CreateWith, CrossSiteScripting, DefaultRoutes, Deserialize, DetailedExceptions, DigestDoS, DivideByZero, DynamicFinders, EOLRails, EOLRuby, EscapeFunction, Evaluation, Execute, FileAccess, FileDisclosure, FilterSkipping, ForceSSL, ForgerySetting, HeaderDoS, I18nXSS, JRubyXML, JSONEncoding, JSONEntityEscape, JSONParsing, LinkTo, LinkToHref, MailTo, MassAssignment, MimeTypeDoS, ModelAttrAccessible, ModelAttributes, ModelSerialize, NestedAttributes, NestedAttributesBypass, NumberToCurrency, PageCachingCVE, PermitAttributes, QuoteTableName, Redirect, RegexDoS, Render, RenderDoS, RenderInline, ResponseSplitting, ReverseTabnabbing, RouteDoS, SQL, SQLCVEs, SSLVerify, SafeBufferManipulation, SanitizeConfigCve, SanitizeMethods, Secrets, SelectTag, SelectVulnerability, Send, SendFile, SessionManipulation, SessionSettings, SimpleFormat, SingleQuotes, SkipBeforeFilter, SprocketsPathTraversal, StripTags, SymbolDoS, SymbolDoSCVE, TemplateInjection, TranslateBug, UnsafeReflection, UnsafeReflectionMethods, UnscopedFind, ValidationRegex, VerbConfusion, WeakHash, WithoutProtection, XMLDoS, YAMLParsing</td>
    </tr>
  </tbody>
</table>
<br>
<h2 id='summary'>Summary</h2>
<table>
  <thead>
    <tr>
      <th>Scanned/Reported</th>
      <th>Total</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td>Controllers</td>
      <td>5</td>
    </tr>
    <tr>
      <td>Models</td>
      <td>3</td>
    </tr>
    <tr>
      <td>Templates</td>
      <td>12</td>
    </tr>
    <tr>
      <td>Errors</td>
      <td>0</td>
    </tr>
    <tr>
      <td>Security Warnings</td>
      <td>8 <span class='high-confidence'>(6)</span></td>
    </tr>
  
    <tr>
      <td>Ignored Warnings</td>
      <td>0</td>
    </tr>
  
  </tbody>
</table>
<br>
<table>
  <thead>
    <tr>
      <th>Warning Type</th>
      <th>Total</th>
    </tr>
  </thead>
  <tbody>
  
    <tr>
      <td>Cross-Site Scripting</td>
      <td>1</td>
    </tr>
  
    <tr>
      <td>Format Validation</td>
      <td>1</td>
    </tr>
  
    <tr>
      <td>Mass Assignment</td>
      <td>1</td>
    </tr>
  
    <tr>
      <td>Missing Encryption</td>
      <td>1</td>
    </tr>
  
    <tr>
      <td>SQL Injection</td>
      <td>2</td>
    </tr>
  
    <tr>
      <td>Weak Hash</td>
      <td>2</td>
    </tr>
  
  </tbody>
</table>
<br>
<h2>Security Warnings</h2>  
<table>
  <thead>
    <tr>
      <th>Confidence</th>
      <th>Class</th>
      <th>Method</th>
      <th>Warning Type</th>
      <th>CWE ID</th>
      <th>Message</th>
    </tr>
  </thead>
  <tbody>
  
    <tr>
      <td><span class='high-confidence'>High</span></td>
      <td></td>
      <td></td>
      <td><a rel="noreferrer" href="https://brakemanscanner.org/docs/warning_types/missing_encryption/">Missing Encryption</a></td>
      <td>[311]</td>
      <td><div class='warning_message' onClick="toggle('context5');toggle('message5');toggle('full_message5')" >The application does not force use of HTTPS: <span class="code">config.force_ssl</span> is not enabled near line 1<table id='context5' class='context' style='display:none'><caption>config/environments/production.rb</caption>      <thead style='display:none'>
        <tr>
          <th>line number</th>
          <th>line content</th>
        </tr>
      </thead>
      <tbody>
        <tr class='context first error'>
          <td class='context_line'>
            <pre class='context'>1</pre>
          </td>
          <td class='context'>
            <pre class='context'>require &quot;active_support/core_ext/integer/time&quot;</pre>
          </td>
        </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>3</pre>
            </td>
            <td class='context'>
              <pre class='context'>Rails.application.configure do</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>4</pre>
            </td>
            <td class='context'>
              <pre class='context'>  # Settings specified here will take precedence over those in config/application.rb.</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>6</pre>
            </td>
            <td class='context'>
              <pre class='context'>  # Code is not reloaded between requests.</pre>
            </td>
          </tr>
</tbody></table></div></td>
    </tr>
  
    <tr>
      <td><span class='high-confidence'>High</span></td>
      <td>PeopleController</td>
      <td>set_person</td>
      <td><a rel="noreferrer" href="https://brakemanscanner.org/docs/warning_types/sql_injection/">SQL Injection</a></td>
      <td>[89]</td>
      <td><div class='warning_message' onClick="toggle('context3');toggle('message3');toggle('full_message3')" >Possible SQL injection near line 65: <span class="code">Person.where(&quot;id = &#39;#{<span class="user_input">params[:id]</span>}&#39;&quot;)</span><table id='context3' class='context' style='display:none'><caption>app/controllers/people_controller.rb</caption>      <thead style='display:none'>
        <tr>
          <th>line number</th>
          <th>line content</th>
        </tr>
      </thead>
      <tbody>
        <tr class='context first'>
          <td class='context_line'>
            <pre class='context'>60</pre>
          </td>
          <td class='context'>
            <pre class='context'>  private</pre>
          </td>
        </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>61</pre>
            </td>
            <td class='context'>
              <pre class='context'>    # Use callbacks to share common setup or constraints between actions.</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>62</pre>
            </td>
            <td class='context'>
              <pre class='context'>    def set_person</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>63</pre>
            </td>
            <td class='context'>
              <pre class='context'>      # SECU (A03:2021-Injection) : </pre>
            </td>
          </tr>
          <tr class='context near_error'>
            <td class='context_line'>
              <pre class='context'>64</pre>
            </td>
            <td class='context'>
              <pre class='context'>      #   risque d&#39;injection SQL</pre>
            </td>
          </tr>
          <tr class='context alt error'>
            <td class='context_line'>
              <pre class='context'>65</pre>
            </td>
            <td class='context'>
              <pre class='context'>      @person = Person.where(&quot;id = &#39;#{params[:id]}&#39;&quot;).first</pre>
            </td>
          </tr>
          <tr class='context near_error'>
            <td class='context_line'>
              <pre class='context'>66</pre>
            </td>
            <td class='context'>
              <pre class='context'>    end</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>68</pre>
            </td>
            <td class='context'>
              <pre class='context'>    # Only allow a list of trusted parameters through.</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>69</pre>
            </td>
            <td class='context'>
              <pre class='context'>    def person_params</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>70</pre>
            </td>
            <td class='context'>
              <pre class='context'>      params.require(:person).permit(:first_name, :last_name, :age, :url_profile)</pre>
            </td>
          </tr>
</tbody></table></div></td>
    </tr>
  
    <tr>
      <td><span class='high-confidence'>High</span></td>
      <td>UsersController</td>
      <td>update</td>
      <td><a rel="noreferrer" href="https://brakemanscanner.org/docs/warning_types/sql_injection/">SQL Injection</a></td>
      <td>[89]</td>
      <td><div class='warning_message' onClick="toggle('context4');toggle('message4');toggle('full_message4')" >Possible SQL injection near line 30: <span class="code">User.where(&quot;id = &#39;#{<span class="user_input">params[:user][:id]</span>}&#39;&quot;)</span><table id='context4' class='context' style='display:none'><caption>app/controllers/users_controller.rb</caption>      <thead style='display:none'>
        <tr>
          <th>line number</th>
          <th>line content</th>
        </tr>
      </thead>
      <tbody>
        <tr class='context first'>
          <td class='context_line'>
            <pre class='context'>25</pre>
          </td>
          <td class='context'>
            <pre class='context'>  end</pre>
          </td>
        </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>27</pre>
            </td>
            <td class='context'>
              <pre class='context'>  def update</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>28</pre>
            </td>
            <td class='context'>
              <pre class='context'>    message = false</pre>
            </td>
          </tr>
          <tr class='context alt error'>
            <td class='context_line'>
              <pre class='context'>30</pre>
            </td>
            <td class='context'>
              <pre class='context'>    user = User.where(&quot;id = &#39;#{params[:user][:id]}&#39;&quot;)[0]</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>32</pre>
            </td>
            <td class='context'>
              <pre class='context'>    if user</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>33</pre>
            </td>
            <td class='context'>
              <pre class='context'>      user.update(user_params_without_password)</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>34</pre>
            </td>
            <td class='context'>
              <pre class='context'>      if params[:user][:password].present? &amp;&amp; (params[:user][:password] == params[:user][:password_confirmation])</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>35</pre>
            </td>
            <td class='context'>
              <pre class='context'>        user.password = params[:user][:password]</pre>
            </td>
          </tr>
</tbody></table></div></td>
    </tr>
  
    <tr>
      <td><span class='high-confidence'>High</span></td>
      <td>User</td>
      <td>User.authenticate</td>
      <td><a rel="noreferrer" href="https://brakemanscanner.org/docs/warning_types/weak_hash/">Weak Hash</a></td>
      <td>[328]</td>
      <td><div class='warning_message' onClick="toggle('context6');toggle('message6');toggle('full_message6')" >Weak hashing algorithm used: MD5 near line 24: <span class="code">Digest::MD5.hexdigest(<span class="user_input">password</span>)</span><table id='context6' class='context' style='display:none'><caption>app/models/user.rb</caption>      <thead style='display:none'>
        <tr>
          <th>line number</th>
          <th>line content</th>
        </tr>
      </thead>
      <tbody>
        <tr class='context first'>
          <td class='context_line'>
            <pre class='context'>20</pre>
          </td>
          <td class='context'>
            <pre class='context'>  def self.authenticate(email, password)</pre>
          </td>
        </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>21</pre>
            </td>
            <td class='context'>
              <pre class='context'>    auth = nil</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>22</pre>
            </td>
            <td class='context'>
              <pre class='context'>    user = find_by_email(email)</pre>
            </td>
          </tr>
          <tr class='context alt near_error'>
            <td class='context_line'>
              <pre class='context'>23</pre>
            </td>
            <td class='context'>
              <pre class='context'>    raise &quot;#{email} doesn&#39;t exist!&quot; if !(user)</pre>
            </td>
          </tr>
          <tr class='context error'>
            <td class='context_line'>
              <pre class='context'>24</pre>
            </td>
            <td class='context'>
              <pre class='context'>    if user.password == Digest::MD5.hexdigest(password)</pre>
            </td>
          </tr>
          <tr class='context alt near_error'>
            <td class='context_line'>
              <pre class='context'>25</pre>
            </td>
            <td class='context'>
              <pre class='context'>      auth = user</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>26</pre>
            </td>
            <td class='context'>
              <pre class='context'>    else</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>27</pre>
            </td>
            <td class='context'>
              <pre class='context'>      raise &quot;Incorrect Password!&quot;</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>28</pre>
            </td>
            <td class='context'>
              <pre class='context'>    end</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>29</pre>
            </td>
            <td class='context'>
              <pre class='context'>    return auth</pre>
            </td>
          </tr>
</tbody></table></div></td>
    </tr>
  
    <tr>
      <td><span class='high-confidence'>High</span></td>
      <td>User</td>
      <td>hash_password</td>
      <td><a rel="noreferrer" href="https://brakemanscanner.org/docs/warning_types/weak_hash/">Weak Hash</a></td>
      <td>[328]</td>
      <td><div class='warning_message' onClick="toggle('context7');toggle('message7');toggle('full_message7')" >Weak hashing algorithm used: MD5 near line 34: <span class="code">Digest::MD5.hexdigest(<span class="user_input">self.password</span>)</span><table id='context7' class='context' style='display:none'><caption>app/models/user.rb</caption>      <thead style='display:none'>
        <tr>
          <th>line number</th>
          <th>line content</th>
        </tr>
      </thead>
      <tbody>
        <tr class='context first'>
          <td class='context_line'>
            <pre class='context'>29</pre>
          </td>
          <td class='context'>
            <pre class='context'>    return auth</pre>
          </td>
        </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>30</pre>
            </td>
            <td class='context'>
              <pre class='context'>  end</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>32</pre>
            </td>
            <td class='context'>
              <pre class='context'>  def hash_password</pre>
            </td>
          </tr>
          <tr class='context alt near_error'>
            <td class='context_line'>
              <pre class='context'>33</pre>
            </td>
            <td class='context'>
              <pre class='context'>    if will_save_change_to_password?</pre>
            </td>
          </tr>
          <tr class='context error'>
            <td class='context_line'>
              <pre class='context'>34</pre>
            </td>
            <td class='context'>
              <pre class='context'>      self.password = Digest::MD5.hexdigest(self.password)</pre>
            </td>
          </tr>
          <tr class='context alt near_error'>
            <td class='context_line'>
              <pre class='context'>35</pre>
            </td>
            <td class='context'>
              <pre class='context'>    end</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>36</pre>
            </td>
            <td class='context'>
              <pre class='context'>  end</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>38</pre>
            </td>
            <td class='context'>
              <pre class='context'>end</pre>
            </td>
          </tr>
</tbody></table></div></td>
    </tr>
  
    <tr>
      <td><span class='med-confidence'>Medium</span></td>
      <td></td>
      <td></td>
      <td><a rel="noreferrer" href="https://brakemanscanner.org/docs/warning_types/cross-site_scripting/">Cross-Site Scripting</a></td>
      <td>[79]</td>
      <td><div class='warning_message' onClick="toggle('context1');toggle('message1');toggle('full_message1')" >HTML entities in JSON are not escaped by default near line 3: <span class="code">ActiveSupport::JSON::Encoding.escape_html_entities_in_json = false</span><table id='context1' class='context' style='display:none'><caption>config/environments/production.rb</caption>      <thead style='display:none'>
        <tr>
          <th>line number</th>
          <th>line content</th>
        </tr>
      </thead>
      <tbody>
        <tr class='context first'>
          <td class='context_line'>
            <pre class='context'>1</pre>
          </td>
          <td class='context'>
            <pre class='context'>require &quot;active_support/core_ext/integer/time&quot;</pre>
          </td>
        </tr>
          <tr class='context alt error'>
            <td class='context_line'>
              <pre class='context'>3</pre>
            </td>
            <td class='context'>
              <pre class='context'>Rails.application.configure do</pre>
            </td>
          </tr>
          <tr class='context near_error'>
            <td class='context_line'>
              <pre class='context'>4</pre>
            </td>
            <td class='context'>
              <pre class='context'>  # Settings specified here will take precedence over those in config/application.rb.</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>6</pre>
            </td>
            <td class='context'>
              <pre class='context'>  # Code is not reloaded between requests.</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>7</pre>
            </td>
            <td class='context'>
              <pre class='context'>  config.cache_classes = true</pre>
            </td>
          </tr>
</tbody></table></div></td>
    </tr>
  
    <tr>
      <td><span class='med-confidence'>Medium</span></td>
      <td>UsersController</td>
      <td>user_params</td>
      <td><a rel="noreferrer" href="https://brakemanscanner.org/docs/warning_types/mass_assignment/">Mass Assignment</a></td>
      <td>[915]</td>
      <td><div class='warning_message' onClick="toggle('context2');toggle('message2');toggle('full_message2')" >Specify exact keys allowed for mass assignment instead of using <span class="code">permit!</span> which allows any keys near line 51: <span class="code">params.require(:user).permit!</span><table id='context2' class='context' style='display:none'><caption>app/controllers/users_controller.rb</caption>      <thead style='display:none'>
        <tr>
          <th>line number</th>
          <th>line content</th>
        </tr>
      </thead>
      <tbody>
        <tr class='context first'>
          <td class='context_line'>
            <pre class='context'>46</pre>
          </td>
          <td class='context'>
            <pre class='context'>  end</pre>
          </td>
        </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>48</pre>
            </td>
            <td class='context'>
              <pre class='context'>  private</pre>
            </td>
          </tr>
          <tr class='context near_error'>
            <td class='context_line'>
              <pre class='context'>50</pre>
            </td>
            <td class='context'>
              <pre class='context'>  def user_params</pre>
            </td>
          </tr>
          <tr class='context alt error'>
            <td class='context_line'>
              <pre class='context'>51</pre>
            </td>
            <td class='context'>
              <pre class='context'>    params.require(:user).permit!</pre>
            </td>
          </tr>
          <tr class='context near_error'>
            <td class='context_line'>
              <pre class='context'>52</pre>
            </td>
            <td class='context'>
              <pre class='context'>  end</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>54</pre>
            </td>
            <td class='context'>
              <pre class='context'>  # unpermitted attributes are ignored in production</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>55</pre>
            </td>
            <td class='context'>
              <pre class='context'>  def user_params_without_password</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>56</pre>
            </td>
            <td class='context'>
              <pre class='context'>    params.require(:user).permit(:email, :first_name, :last_name)</pre>
            </td>
          </tr>
</tbody></table></div></td>
    </tr>
  
  </tbody>
</table>
<p>Model Warnings</p>
<table>
  <thead>
    <tr>
      <th>Confidence</th>
      <th>Model</th>
      <th>Warning Type</th>
      <th>CWE ID</th>
      <th>Message</th>
    </tr>
  </thead>
  <tbody>
  
    <tr>
      <td><span class='high-confidence'>High</span></td>
      <td>User</td>
      <td><a rel="noreferrer" href="https://brakemanscanner.org/docs/warning_types/format_validation/">Format Validation</a></td>
      <td>[777]</td>
      <td><div class='warning_message' onClick="toggle('context8');toggle('message8');toggle('full_message8')" >Insufficient validation for <span class="code">email</span> using <span class="code">/.+@.+\..+/i</span>. Use <span class="code">\A</span> and <span class="code">\z</span> as anchors near line 10<table id='context8' class='context' style='display:none'><caption>app/models/user.rb</caption>      <thead style='display:none'>
        <tr>
          <th>line number</th>
          <th>line content</th>
        </tr>
      </thead>
      <tbody>
        <tr class='context first'>
          <td class='context_line'>
            <pre class='context'>5</pre>
          </td>
          <td class='context'>
            <pre class='context'>                       on: :create,</pre>
          </td>
        </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>6</pre>
            </td>
            <td class='context'>
              <pre class='context'>                       if: :password</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>8</pre>
            </td>
            <td class='context'>
              <pre class='context'>  validates_presence_of :email</pre>
            </td>
          </tr>
          <tr class='context alt near_error'>
            <td class='context_line'>
              <pre class='context'>9</pre>
            </td>
            <td class='context'>
              <pre class='context'>  validates_uniqueness_of :email</pre>
            </td>
          </tr>
          <tr class='context error'>
            <td class='context_line'>
              <pre class='context'>10</pre>
            </td>
            <td class='context'>
              <pre class='context'>  validates_format_of :email, with: /.+@.+\..+/i</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>12</pre>
            </td>
            <td class='context'>
              <pre class='context'>  before_save :hash_password</pre>
            </td>
          </tr>
          <tr class='context'>
            <td class='context_line'>
              <pre class='context'>14</pre>
            </td>
            <td class='context'>
              <pre class='context'>  def full_name</pre>
            </td>
          </tr>
          <tr class='context alt'>
            <td class='context_line'>
              <pre class='context'>15</pre>
            </td>
            <td class='context'>
              <pre class='context'>    &quot;#{self.first_name} #{self.last_name}&quot;</pre>
            </td>
          </tr>
</tbody></table></div></td>
    </tr>
  
  </tbody>
</table></body></html>